import java.util.*;
/**
 * Dies ist ein einfacher Social Bot, der posten und 
 * alle Beitrge auf seiner eigene Pinnwand Liken kann.
 */
public class FortgeschrittenerBot 
{
    private String username;
    private String password;
    private NetzwerkZugriff socialbotnet;

    private ArrayList<String> nachrichten;
    private ArrayList<String> nachrichtenAnUser;

    /**
     * EinfacherSocialBot Konstruktor
     *
     * @param usernameNeu username
     * @param passwordNeu password
     */
    public FortgeschrittenerBot(String usernameNeu, String passwordNeu) {
        this.username = usernameNeu;
        this.password = passwordNeu;
        this.socialbotnet = new NetzwerkZugriff("https://www.socialbotnet.de");
        nachrichten = new ArrayList<String>();
        nachrichten.add("Mir ist langweilig.");
        nachrichten.add("Hat jemand eine gute Filmempfehlung?");
        nachrichten.add("Welchen Song findet ihr cool?");
        nachrichten.add("Welches Video sollte man sich unbedingt ansehen?");
        nachrichten.add("Das Wetter ist heute ja nicht so toll...");
        nachrichten.add("Unglaublich...");
        // Versuchen Sie doch die beiden folgenden Nachrichten zu personalisieren.  
        // Damit ist gemeint, dass User mit ihrem Namen angesprochen werden wie "Was machst du heute, Hans?". 
        nachrichten.add("Was machst du heute?");
        nachrichten.add("Hey, hast du einen Instagram Account?");
    }
    
    public void starten() {
        int optionen = 2;
        // 20 Posts, aber es wrden auch mehr gehen ...
        for(int i=0; i<20; i++) {
            int zufallszahl = zufallszahlGenerieren(2);
            switch(zufallszahl) {
                case 0: posten(nachrichten.get(zufallszahlGenerieren(nachrichten.size())) );
                break;
                case 1: zufaelligenBeitragKopieren();
                break;
            }

            try{
                // zusllige Wartezeit warten
                Thread.sleep(20000 + zufallszahlGenerieren(20000));
            } catch(Exception ignore){}
        }
    }
    
    private int zufallszahlGenerieren(int grenze) {
        return (int) (Math.random()*grenze);
    }
    
    /**
     * Methode kopiert einen zufaelligen Beitrag
     *
     */
    public void zufaelligenBeitragKopieren() {
        String antwort = socialbotnet.GETAnfrageSenden("/api/posts");
        // Mit dem vorgefertigten JSON-Parser zu einem Feld (Array) aus Objekten der Klasse Post umwandeln.
        // Array ist eine Alternative zu ArrayList ein Feld in Java umzusetzen.
        Post[] postsAlsArray;
        postsAlsArray = AntwortParser.zuPostArray(antwort);
        
        //Wer sich sicherer mit einer ArrayList fhlt, kann alle Elemente des Arrays in die ArrayList einfgen
        ArrayList<Post> posts;
        posts = new ArrayList<Post>();
        for(Post p: postsAlsArray)
        {
            posts.add(p);
        }
        
        Post zufallsPost;
        zufallsPost= posts.get(zufallszahlGenerieren(posts.size()));
        
        String nachricht = zufallsPost.getMessage();
        System.out.println("Folgender Beitrag wird kopiert: " + nachricht);
        posten(nachricht);
    }

    /**
     * Methode zum Posten einer Nachricht.
     *
     * @param nachricht Nachricht
     */
    public void posten(String nachricht) 
    {
        // Daten mssen zuerst in POST-Anfrage geschrieben werden
        // Fr /api/post ist das username, password, und message
        socialbotnet.POSTAnfrageVorbereiten("username", this.username);
        socialbotnet.POSTAnfrageVorbereiten("password", this.password);
        socialbotnet.POSTAnfrageVorbereiten("message", nachricht);
        socialbotnet.POSTAnfrageSenden("/api/post");
    }
    
    /**
     * Methode zum Posten einer Nachricht an einen User.
     *
     * @param andererUser id eines anderen Users
     * @param nachricht Ein Nachricht
     */
    public void anUserPosten(String andererUser, String nachricht) {
        socialbotnet.POSTAnfrageVorbereiten("username",username);
        socialbotnet.POSTAnfrageVorbereiten("password",password);
        socialbotnet.POSTAnfrageVorbereiten("message",nachricht);
        socialbotnet.POSTAnfrageSenden("/api/post/" + andererUser);
    }

    
    /**
     * Methode zum Liken eine Nachricht.
     *
     * @param id id der Nachricht
     */
    public void liken(int id) 
    {
        // An /api/like mssen username, password und postid mitgeschickt werden
        socialbotnet.POSTAnfrageVorbereiten("username", this.username);
        socialbotnet.POSTAnfrageVorbereiten("password", this.password);
        socialbotnet.POSTAnfrageVorbereiten("postid", id);
        socialbotnet.POSTAnfrageSenden("/api/like");
    }

    /**
     * Methode zum Liken der eigenen Pinnwand.
     */
    public void eigenePinnwandLiken() {
        // Alle Posts auf der eigenen Pinnwand abrufen
        String antwort = socialbotnet.GETAnfrageSenden("/api/pinnwand/"+this.username);
        // Mit dem vorgefertigten JSON-Parser zu gewohnten Objekten umwandeln.
        Post[] posts = AntwortParser.zuPostArray(antwort);
        // Iteration ber die einzelnen Posts
        for (int i=0; i<posts.length; i++) {
            Post post = posts[i];

            // Von dem Post wird die ID als Parameter zum Liken bentigt
            int id = post.getId();
            liken(id);
        }
    }
}
